#!/usr/bin/python
import RPi.GPIO as GPIO
import fluidsynth
import time

fs = fluidsynth.Synth()
fs.start('alsa','hw:Device,0')
sfid = fs.sfload("/home/pi/p.sf2")
fs.program_select(0, sfid, 0, 0)
volume = 110

buttons = [20, 16, 13, 6, 12, 5, 7, 11, 8, 25, 10, 24, 23, 17, 15, 14, 4]
# define the buttons to GPIO
notes = [60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76]
NUMBUTTONS = len(buttons)
GPIO.setmode(GPIO.BCM)
GPIO.setup(27,GPIO.OUT)
GPIO.output(27,GPIO.HIGH) # Ready Light

def playNote(channel):
    i = 0
    while i < NUMBUTTONS:
        if channel == buttons[i]:
            if GPIO.input(buttons[i]) == 0:
                fs.noteon(0, notes[i], volume)
            else:
                fs.noteoff(0, notes[i])
        i += 1
        
for b in buttons:
    GPIO.setup(b,GPIO.IN, pull_up_down=GPIO.PUD_UP)
    
for e in buttons:
    GPIO.add_event_detect(e, GPIO.BOTH, callback=playNote, bouncetime=20)
    time.sleep(0.1) #There is bug in event detect if you create new threads too quickly
    

try:
    while True:         # Just to keep the program running
        time.sleep(2)

except:
    GPIO.cleanup()
    fs.delete()